<?php
/**
* Adds TinyMCE Editor buttons for shortcode
*/
class Pm_Sbox_Editor
{
	public function init_plugin() {
		// Don't bother if user does not have permissions
		if ( current_user_can('edit_posts') && current_user_can('edit_pages') ) {
			add_filter( 'mce_external_plugins', array( $this, 'tmce_plugin' ) );
			add_filter( 'mce_buttons', array( $this, 'tmce_buttons' ) );
		}
	}

	public function tmce_plugin( $plugins ) {
		$plugins['pmsbox_button'] = PM_SBOX_DIR.'modules/src/js/tinymce.js';
		return $plugins;
	}

	public function tmce_buttons( $buttons ) {
		array_push( $buttons, 'pm_sbox_mce_button' );
    	return $buttons;
	}
}