<?php

/*
	* ShortCode
	* pm_sbox_shortcode
*/

function pm_sbox_shortcode( $atts = array(), $content = null ) {
	$atts = shortcode_atts( array(
		'limit' => '',
		'pid' => '',
		), $atts, 'pm-suggestions' );
	$allow_guest = get_option(PM_SBOX_SETTINGS_OPTION.'_guest');
	$limit_day = get_option(PM_SBOX_SETTINGS_OPTION.'_limit_day');
	$current_ip = pm_get_the_user_ip();
	$pm_status_like = '_pm_sbox_like';
	$pm_status_dislike = '_pm_sbox_dislike';
	$pm_sbox_meta = '_pm_sbox_meta';
	$user_votes = '';
	$uid = '';
	if ( is_user_logged_in() ) {
		$uid = get_current_user_id();
		$user_votes = (is_array(get_user_meta($uid,$pm_sbox_meta,true)) ? get_user_meta($uid,$pm_sbox_meta,true) : array());
	} elseif ( !is_user_logged_in() && $allow_guest ) {
		$uid = $current_ip;
		$user_votes = pm_sbox_ips($current_ip);
	}

	$submit_suggestion = '';
	//wp_enqueue_script( 'pm-sbox-admin-script', PM_sbox_DIR.'modules/src/js/pm-sbox.js', array('jquery'), PM_SBOX_VERSION, true );
	wp_enqueue_script('pm-sbox-frontend-script', PM_SBOX_DIR.'modules/frontend/js/pm-fe-sbox.js', array('jquery'), PM_SBOX_VERSION, true );
	wp_enqueue_style( 'pm-sbox-frontend-chosen-style', PM_SBOX_DIR.'modules/frontend/css/pm-sbox-style.css', '', PM_SBOX_VERSION, 'all' );
	wp_localize_script( 'pm-sbox-frontend-script', 'myAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' )));
	global $wp_query;
	
	$output = '';
	$output .= '<div class="suggestion_box_wrapper">';
	$output .= '<ul>';
	
	if( isset($atts['pid']) ) {
		$args = array(
			'p' => $atts['pid'],
			'post_type' => array('suggestion_box')
		);
	} else {
		$args = array(
			'posts_per_page' => $atts['limit'],
			'post_type' => array('suggestion_box')
		);
	}
	
	$query = new WP_Query( $args );
	// The Loop
	while ( $query->have_posts() ) { $query->the_post();
		//End Suggestion when Expired by Date
		pm_sbox_expire_suggestion($query->post->ID);
		
		$title = get_the_title( $query->post->ID );
		$link = get_permalink( $query->post->ID );
		$pm_cur_likes = (get_post_meta($query->post->ID,$pm_status_like,true) ? get_post_meta($query->post->ID,$pm_status_like,true) : 0);
		$pm_cur_dislikes = (get_post_meta($query->post->ID,$pm_status_dislike,true) ? get_post_meta($query->post->ID,$pm_status_dislike,true) : 0);
		$end_voting = get_post_meta($query->post->ID, '_pm_end_voting', true);
		//HTML for Voting
		$vhtml = '<span class="pm_sbox_done" style="display: none;">'.esc_html(__( 'Thanks for voting!', 'pm-suggestion-box' )).'</span>';
		$vhtml .= "<span class='pm_sbox_btn_style available pm_sbox_btn pm_sbox_like'  data-status='like' data-pid='{$query->post->ID}'>+ ".esc_html(__('Like', 'pm-suggestion-box'))." {$pm_cur_likes}</span>";
		$vhtml .= "<span class='pm_sbox_btn_style available pm_sbox_btn pm_sbox_dislike'  data-status='dislike' data-pid='{$query->post->ID}'>- ".esc_html(__('Dislike', 'pm-suggestion-box'))." {$pm_cur_dislikes}</span> ";
		if(!$end_voting) {
			$output .= "<li>";		
			if (is_user_logged_in() || $allow_guest) {
				if(!array_key_exists($query->post->ID,$user_votes)) {
					$output .= $vhtml;
				} else {
					$output .= "<span class='pm_sbox_btn_style done pm_sbox_like'>".esc_html(__('Like', 'pm-suggestion-box'))." {$pm_cur_likes}</span>";
					$output .= "<span class='pm_sbox_btn_style done pm_sbox_dislike'>".esc_html(__('Dislike', 'pm-suggestion-box'))." {$pm_cur_dislikes}</span> ";
					$output .= "<span class='pm_sbox_done_voting'>".esc_html(__( 'Voted!', 'pm-suggestion-box' ))." </span>";
				}
			} else {
				$output .= "<span>".esc_html(__( 'You must be Logged in.', 'pm-suggestion-box' ))." </span>";
			}//End if Logged in
			
			$output .= "<a class='pm_sbox_title' href='{$link}'>{$title}</a>";
			$output .= "</li>";
		}// Not Vote End
	}
	// Restore original Post Data
	wp_reset_postdata();
	
	//$atts['limit'];
	$output .= '</ul>';
	//$output .= "<p><a href='{$submit_suggestion}' class='pm_sbox_submit'>".esc_html(__('Submit your own Suggestion','pm-suggestion-box'))."</a></p>";
	$output .= '</div>';
	$output .= pm_sbox_style();
	return $output;
}

add_shortcode( 'pm-suggestions', 'pm_sbox_shortcode' );

/*
	* ShortCode
	* pm_sbox_shortcode_create
*/

function pm_sbox_shortcode_create( $atts ) { 
	$output = '';
	$allow_auto_end = (get_option(PM_SBOX_SETTINGS_OPTION.'_auto_end') ? true : false);
	$allow_front_create = (get_option(PM_SBOX_SETTINGS_OPTION.'_public_create') ? true : false);
	$new_suggestion_status = (get_option(PM_SBOX_SETTINGS_OPTION.'_new_suggestion_status') ? get_option(PM_SBOX_SETTINGS_OPTION.'_new_suggestion_status') : 'draft'); 

	if($allow_front_create):
		wp_enqueue_script( 'jquery-ui-datepicker' );
		//wp_register_style( 'pm-sbox-jquery-ui-styles','https://ajax.googleapis.com/ajax/libs/jqueryui/1.11.2/themes/smoothness/jquery-ui.css', '', PM_SBOX_VERSION, 'all'  );
		//wp_enqueue_style( 'pm-sbox-jquery-ui-styles' );
		wp_enqueue_script('pm-sbox-frontend-script-submit', PM_SBOX_DIR.'modules/frontend/js/pm-fe-sbox-submit.js', array('jquery'), PM_SBOX_VERSION, true );
		wp_enqueue_style( 'pm-sbox-admin-chosen-style', PM_SBOX_DIR.'modules/frontend/css/pm-sbox-style.css', '', PM_SBOX_VERSION, 'all' );
		$output .= '<div class="suggestion_box_create_wrapper suggestion_box_wrapper">';
		if( isset($_POST['pm_sbox_create_submit']) ):
			$pm_title = wp_strip_all_tags($_POST['pm_sbox_create_title']);
			if( !empty($pm_title) ) {			
				// Create post object
				$my_post = array(
					'post_type' => 'suggestion_box',
					'post_title'    => $pm_title,
					'post_content'  => wp_strip_all_tags( $_POST['pm_sbox_create_desc'] ),
					'post_status'   => $new_suggestion_status
				);
				// Insert the post into the database
				$post_id = wp_insert_post( $my_post );
				if($post_id && $allow_auto_end) {
					$end_type = (isset($_POST['_pm_end_type']) ? esc_html($_POST['_pm_end_type']) : null);
					$end_type_date = (isset($_POST['_pm_sbox_end_date']) ? esc_html($_POST['_pm_sbox_end_date']) : null);
					$end_type_total_vote = (isset($_POST['_pm_sbox_end_total_vote']) ? absint($_POST['_pm_sbox_end_total_vote']) : null);
					
					//Updates Endtype based on settings
					update_post_meta($post_id,'_pm_end_type',$end_type);
					if($end_type == 'date') {
						update_post_meta($post_id,'_pm_sbox_end_date',$end_type_date);
					} elseif($end_type == 'total_vote') {
						update_post_meta($post_id,'_pm_sbox_end_total_vote',$end_type_total_vote);
					}
				}//End Allow
				
				$output .= '<div class="pm_success">'.esc_html(__( 'Your suggestion is submitted and is being reviewed.', 'pm-suggestion-box' )).'</div>';
			} else {
				$output .= '<div class="pm_error">'.esc_html(__( 'There is an error in submitting your suggestion.', 'pm-suggestion-box' )).'</div>';
			}
			
		endif; // if submit
		$output .= '<form id="suggestion_box_create_form" name="suggestion_box_create_form" method="post" action="">';
		$output .= '<fieldset>';
		$output .= '<legend>'.esc_html(__( 'Suggestion Details', 'pm-suggestion-box' )).'</legend>';
		$output .= '<div><label for="pm_sbox_create_title">'.esc_html(__( 'Title', 'pm-suggestion-box' )).'</label><br />';
		$output .= '<input type="text" name="pm_sbox_create_title" id="pm_sbox_create_title" /></div>';
		
		$output .= '<div><label for="pm_sbox_create_desc">'.esc_html(__( 'Description', 'pm-suggestion-box' )).'</label><br />';
		$output .= '<textarea name="pm_sbox_create_desc" id="pm_sbox_create_desc" ></textarea></div>';
		if($allow_auto_end):
			$output .= '<div id="pm_end_type_wrapper"><p class="description">'.esc_html(__( 'End Method', 'pm-suggestion-box' )).'</p>';
			$output .= '<input type="radio" name="_pm_end_type" value="date" checked id="pm_end_type_date" class="pm_end_type"> <label for="pm_end_type_date">'.esc_html(__( 'Date', 'pm-suggestion-box' )).'</label><br />';
			$output .= '<input type="radio" name="_pm_end_type" value="total_vote" id="pm_end_type_total_vote"  class="pm_end_type"> <label for="pm_end_type_total_vote">'.esc_html(__( 'Total Vote', 'pm-suggestion-box' )).'</label>';
			$output .= '</div>';
			$output .= '<div id="pm_end_type_date_wrapper" class="pm_end_type_wrapper"><label for="pm_sbox_end_date">'.esc_html(__( 'End Date', 'pm-suggestion-box' )).'</label><br />';
			$output .= '<input type="text" name="_pm_sbox_end_date" id="pm_sbox_end_date" placeholder="mm/dd/yyyy" /></div>';
			
			$output .= '<div id="pm_end_type_total_vote_wrapper" class="pm_end_type_wrapper" style="display: none;"><label for="pm_sbox_end_total_vote">'.esc_html(__( 'Total vote reached', 'pm-suggestion-box' )).'</label><br />';
			$output .= '<input type="number" name="_pm_sbox_end_total_vote" id="pm_sbox_end_total_vote" placeholder="Enter number" min="1" /></div>';	
		endif;//Auto End
		$output .= '<div><input type="submit" name="pm_sbox_create_submit" id="pm_sbox_create_submit" value="'.__('Submit', 'pm-suggestion-box').'" /></div>';
		$output .= '</fieldset>';
		$output .= '</form></div>';
	endif;
	return $output;
}

add_shortcode( 'pm-suggestions-create', 'pm_sbox_shortcode_create' );